#include "mastermind.h"
#include <forms.h>
#include "mainwindowdesign.h"
#include "guiglobal.h"

/* Callback routines */

void guitoapp_user_wants_to_quit(FL_OBJECT *, long);
void guitoapp_user_wants_help(FL_OBJECT *, long);
void guitoapp_user_entered_try(FL_OBJECT *, long);
void guitoapp_get_solution(FL_OBJECT *, long);
void guitoapp_user_wants_new_game(FL_OBJECT *, long);
void guitoapp_empty_callback(FL_OBJECT *, long);
void guitoapp_key_pressed(FL_OBJECT *, long);

void guitoapp_user_wants_to_quit(FL_OBJECT *obj, long number)
{
  mastermind_user_wants_to_quit();
}

void guitoapp_user_wants_help(FL_OBJECT *obj, long number)
{
  mastermind_user_wants_help();
}

/* The user entered a try completely and wants to see the answer */
void guitoapp_user_entered_try(FL_OBJECT *obj, long number)
{
  /* Call the function: mastermind_user_enetered_try */
  mastermind_user_entered_try(number);
}

/* The user wants to see the correct solution */
void guitoapp_show_correct_solution(FL_OBJECT *obj, long number)
{
  mastermind_show_correct_solution();
}

void guitoapp_user_wants_new_game(FL_OBJECT *obj, long number)
{
  mastermind_user_wants_new_game();
}

void guitoapp_empty_callback(FL_OBJECT *obj, long number)
{
}

void guitoapp_key_pressed(FL_OBJECT *obj, long ch)
{
  int     position = 0;
  BOOLEAN inform   = FALSE;

  /*
    only if the key was pressed while the mouse is over
    a input field inform the application. 
   */

  for (position = 0; 
       (position < (WIDTH * HEIGHT))
	 && (!inform); 
       position++)
    {
      inform = mainwindow->game_area_choice[position]->belowmouse;
    }

  position--;
  if (inform)
    mastermind_key_pressed(ch, position);
}
